package laba1Loco;

import java.awt.Color;

public class ExtentionDrawingTrain {
    /// <summary>
    /// Создание объекта из строки
    /// </summary>
    /// <param name="info">Строка с данными для создания объекта</param>
    /// <param name="separatorForObject">Разделитель даннных</param>
    /// <param name="width">Ширина</param>
    /// <param name="height">Высота</param>
    /// <returns>Объект</returns>
    public static DrawingTrain CreateDrawingTrain(String info, String separatorForObject, int width, int height)
    {
        String[] strs = info.split(separatorForObject);
        if (strs.length == 4)
        {
            String[] colorValues = strs[2].split(",");

            return new DrawingTrain(Integer.parseInt(strs[0]), (double)Integer.parseInt(strs[1]),
            new Color(
                Integer.parseInt(colorValues[0]),
                Integer.parseInt(colorValues[1]),
                Integer.parseInt(colorValues[2])
                ),
            Integer.parseInt(strs[3]), width, height);
        }
        if (strs.length == 8)
        {
            String[] colorValues = strs[2].split(",");
            String[] colorValues2 = strs[4].split(",");
            return new DrawingLoco(
            Integer.parseInt(strs[0]),
            (double)Integer.parseInt(strs[1]),
            new Color(
                Integer.parseInt(colorValues[0].replaceAll("\\D", "")),
                Integer.parseInt(colorValues[1].replaceAll("\\D", "")),
                Integer.parseInt(colorValues[2].replaceAll("\\D", ""))
                ),
            Integer.parseInt(strs[3]),
            new Color(
                Integer.parseInt(colorValues2[0].replaceAll("\\D", "")),
                Integer.parseInt(colorValues2[1].replaceAll("\\D", "")),
                Integer.parseInt(colorValues2[2].replaceAll("\\D", ""))
                ),
            strs[5].equals("True"),
            strs[6].equals("True"),
            strs[7].equals("True"),
            width, height);
        }
        return null;
    }
    /// <summary>
    /// Получение данных для сохранения в файл
    /// </summary>
    /// <param name="drawningtrain">Сохраняемый объект</param>
    /// <param name="separatorForObject">Разделитель даннных</param>
    /// <returns>Строка с данными по объекту</returns>
    public static String GetDataForSave(DrawingTrain drawningTrain, String separatorForObject)
    {
        EntityTrain train = drawningTrain.EntityTrain;
        if (train == null)
        {
            return null;
        }
        String str = "" + train.Speed + separatorForObject + (int)train.Weight + separatorForObject + train.BodyColor + separatorForObject + train.numWheel;
        if (!(train instanceof EntityLoco))
        {
            return str;
        }
        return str+separatorForObject+((EntityLoco)train).AdditionalColor.toString()+separatorForObject+((EntityLoco)train).Tube+separatorForObject+((EntityLoco)train).FuelTank+separatorForObject+((EntityLoco)train).LocoLine;
    }
}
